load pos1.dat
load pos2.dat
C=3e8;
a=500e-9;
dt=1.6e-17;
max_iter = 32768;

FT_field = fft(pos1(:,2));
AV_FT_field = rand(max_iter/2+1,2);
FT_result = rand(max_iter/2+1,3);
FT_field2 = fft(pos2(:,2));
AV_FT_field2 = rand(max_iter/2+1,2);
FT_result2 = rand(max_iter/2+1,3);

for i=1:max_iter
	FT_result(i,1) = i;
	FT_result(i,2) = AV_FT_field(i,1) = ((i-1)/(max_iter*dt))*(a/C);
	FT_result(i,3) = AV_FT_field(i,2) = abs(FT_field(i));
	FT_result2(i,1) = i;
	FT_result2(i,2) = AV_FT_field2(i,1) = ((i-1)/(max_iter*dt))*(a/C);
	FT_result2(i,3) = AV_FT_field2(i,2) = abs(FT_field2(i));
endfor


save FT_result.dat FT_result
save FT_result2.dat FT_result2
