#define PML 10
#define posit(x,y,z)  (((x)*ny+(y))*nz+(z))
#define pml(x,y,z)  (((x)*ny+(y))*PML+(z))
#define SQUARE(x) ((x)*(x))
#define S MU_0/EPSILON_0

#define MAKE_TRI_STRUCTURE              \
  nx = (int)ceilf(a/dx)+2;              \
  ny = (int)ceilf(a*sqrt(3)/(dx))+2;            \
  nz = (int)ceilf(a*fnz/dx);	      \
  R1=a;	          \
  R2=sqrt(3)*a;	          \
  k1=2*M_PI*k1/a;           \
  k2=2*M_PI*k2/a;           \
  if(nx>=ny)  maxn=nx;	            \
  else	maxn=ny;              \
  if(maxn>=nz)	maxn=maxn;              \
  else	maxn=nz;              \
  x0 = (int)ceilf(nx/2);            \
  y0 = (int)ceilf(ny/2);            \
  z0 = (int)ceilf(nz/2);            \
  r = r/dx;           \
  t = t/dx;           \
  d = d/dx;           \
  Cb = (float *)malloc(sizeof(float)*nx*ny*nz);	            \
  Ex = (float *)malloc(sizeof(float)*nx*ny*nz);	            \
  Ey = (float *)malloc(sizeof(float)*nx*ny*nz);	            \
  Ez = (float *)malloc(sizeof(float)*nx*ny*nz);	            \
  Hx = (float *)malloc(sizeof(float)*nx*ny*nz);	            \
  Hy = (float *)malloc(sizeof(float)*nx*ny*nz);	            \
  Hz = (float *)malloc(sizeof(float)*nx*ny*nz);	            \
  Euxy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Euxz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Euyx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Euyz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Euzx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Euzy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Huxy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Huxz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Huyx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Huyz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Huzx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Huzy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Ebxy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Ebxz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Ebyx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Ebyz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Ebzx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Ebzy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Hbxy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Hbxz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Hbyx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Hbyz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Hbzx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Hbzy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  bzero(Ex,sizeof(float)*nx*ny*nz);           \
  bzero(Ey,sizeof(float)*nx*ny*nz);           \
  bzero(Ez,sizeof(float)*nx*ny*nz);           \
  bzero(Hx,sizeof(float)*nx*ny*nz);           \
  bzero(Hy,sizeof(float)*nx*ny*nz);           \
  bzero(Hz,sizeof(float)*nx*ny*nz);           \
  bzero(Euxy,sizeof(float)*nx*ny*PML);	        \
  bzero(Euxz,sizeof(float)*nx*ny*PML);	        \
  bzero(Euyx,sizeof(float)*nx*ny*PML);	        \
  bzero(Euyz,sizeof(float)*nx*ny*PML);	        \
  bzero(Euzx,sizeof(float)*nx*ny*PML);	        \
  bzero(Euzy,sizeof(float)*nx*ny*PML);	        \
  bzero(Huxy,sizeof(float)*nx*ny*PML);	        \
  bzero(Huxz,sizeof(float)*nx*ny*PML);	        \
  bzero(Huyx,sizeof(float)*nx*ny*PML);	        \
  bzero(Huyz,sizeof(float)*nx*ny*PML);	        \
  bzero(Huzx,sizeof(float)*nx*ny*PML);	        \
  bzero(Huzy,sizeof(float)*nx*ny*PML);	        \
  bzero(Ebxy,sizeof(float)*nx*ny*PML);	        \
  bzero(Ebxz,sizeof(float)*nx*ny*PML);	        \
  bzero(Ebyx,sizeof(float)*nx*ny*PML);	        \
  bzero(Ebyz,sizeof(float)*nx*ny*PML);	        \
  bzero(Ebzx,sizeof(float)*nx*ny*PML);	        \
  bzero(Ebzy,sizeof(float)*nx*ny*PML);	        \
  bzero(Hbxy,sizeof(float)*nx*ny*PML);	        \
  bzero(Hbxz,sizeof(float)*nx*ny*PML);	        \
  bzero(Hbyx,sizeof(float)*nx*ny*PML);	        \
  bzero(Hbyz,sizeof(float)*nx*ny*PML);	        \
  bzero(Hbzx,sizeof(float)*nx*ny*PML);	        \
  bzero(Hbzy,sizeof(float)*nx*ny*PML);	        \
  for(i=0;i<nx;i++)							\
    for(j=0;j<ny;j++)							\
      for(k=0;k<nz;k++)							\
      {									\
	if( k< (d/2 + (float)z0) && k>= ((float)z0-d/2) )		      \
	  Cb[posit(i,j,k)] = dt/(dx*indexs[1]*indexs[1]*EPSILON_0);	      \
	else if(  k < ((float)z0-d/2) )					      \
	  Cb[posit(i,j,k)] = dt/(dx*indexs[2]*indexs[2]*EPSILON_0);	      \
	else								      \
	  Cb[posit(i,j,k)] = dt/(dx*indexs[0]*indexs[0]*EPSILON_0);	      \
	if( k< (d/2 + (float)z0) && k>= ((float)z0+d/2-t) )		\
	{								\
	  if( (i-x0)*(i-x0) + (j-y0)*(j-y0)<r*r )			\
	    Cb[posit(i,j,k)] = dt/(dx*indexs[3]*indexs[3]*EPSILON_0);	\
	  else if( (i-1)*(i-1) + (j-1)*(j-1)<r*r )			\
	    Cb[posit(i,j,k)] = dt/(dx*indexs[3]*indexs[3]*EPSILON_0);	\
	  else if( (i-nx+1)*(i-nx+1) + (j-1)*(j-1)<r*r )		\
	    Cb[posit(i,j,k)] = dt/(dx*indexs[3]*indexs[3]*EPSILON_0);	\
	  else if( (i-1)*(i-1) + (j-ny+1)*(j-ny+1)<r*r )		\
	    Cb[posit(i,j,k)] = dt/(dx*indexs[3]*indexs[3]*EPSILON_0);	\
	  else if( (i-nx+1)*(i-nx+1) + (j-ny+1)*(j-ny+1)<r*r )		\
	    Cb[posit(i,j,k)] = dt/(dx*indexs[3]*indexs[3]*EPSILON_0);	\
	}								\
      }									\
  Db = dt/(dx*MU_0);

#define MAKE_SQUARE_STRUCTURE				  \
  nx = ny = (int)ceilf(a/dx)+2;				  \
  nz = (int)ceilf(a*fnz/dx);				  \
  R1=R2=a;						  \
  k1=2*M_PI*k1/a;					  \
  k2=2*M_PI*k2/a;					  \
  if(nx>=ny)  maxn=nx;					  \
  else	maxn=ny;					  \
  if(maxn>=nz)	maxn=maxn;				  \
  else	maxn=nz;					  \
  x0 = (int)ceilf(nx/2);				  \
  y0 = (int)ceilf(ny/2);				  \
  z0 = (int)ceilf(nz/2);				  \
  r = r/dx;						  \
  t = t/dx;						  \
  d = d/dx;						  \
  Cb = (float *)malloc(sizeof(float)*nx*ny*nz);	          \
  Ex = (float *)malloc(sizeof(float)*nx*ny*nz);	          \
  Ey = (float *)malloc(sizeof(float)*nx*ny*nz);	          \
  Ez = (float *)malloc(sizeof(float)*nx*ny*nz);	          \
  Hx = (float *)malloc(sizeof(float)*nx*ny*nz);	          \
  Hy = (float *)malloc(sizeof(float)*nx*ny*nz);	          \
  Hz = (float *)malloc(sizeof(float)*nx*ny*nz);	          \
  Euxy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Euxz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Euyx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Euyz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Euzx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Euzy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Huxy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Huxz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Huyx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Huyz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Huzx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Huzy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Ebxy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Ebxz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Ebyx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Ebyz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Ebzx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Ebzy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Hbxy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Hbxz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Hbyx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Hbyz = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Hbzx = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  Hbzy = (float *)malloc(sizeof(float)*nx*ny*PML);        \
  bzero(Ex,sizeof(float)*nx*ny*nz);           \
  bzero(Ey,sizeof(float)*nx*ny*nz);           \
  bzero(Ez,sizeof(float)*nx*ny*nz);           \
  bzero(Hx,sizeof(float)*nx*ny*nz);           \
  bzero(Hy,sizeof(float)*nx*ny*nz);           \
  bzero(Hz,sizeof(float)*nx*ny*nz);           \
  bzero(Euxy,sizeof(float)*nx*ny*PML);	        \
  bzero(Euxz,sizeof(float)*nx*ny*PML);	        \
  bzero(Euyx,sizeof(float)*nx*ny*PML);	        \
  bzero(Euyz,sizeof(float)*nx*ny*PML);	        \
  bzero(Euzx,sizeof(float)*nx*ny*PML);	        \
  bzero(Euzy,sizeof(float)*nx*ny*PML);	        \
  bzero(Huxy,sizeof(float)*nx*ny*PML);	        \
  bzero(Huxz,sizeof(float)*nx*ny*PML);	        \
  bzero(Huyx,sizeof(float)*nx*ny*PML);	        \
  bzero(Huyz,sizeof(float)*nx*ny*PML);	        \
  bzero(Huzx,sizeof(float)*nx*ny*PML);	        \
  bzero(Huzy,sizeof(float)*nx*ny*PML);	        \
  bzero(Ebxy,sizeof(float)*nx*ny*PML);	        \
  bzero(Ebxz,sizeof(float)*nx*ny*PML);	        \
  bzero(Ebyx,sizeof(float)*nx*ny*PML);	        \
  bzero(Ebyz,sizeof(float)*nx*ny*PML);	        \
  bzero(Ebzx,sizeof(float)*nx*ny*PML);	        \
  bzero(Ebzy,sizeof(float)*nx*ny*PML);	        \
  bzero(Hbxy,sizeof(float)*nx*ny*PML);	        \
  bzero(Hbxz,sizeof(float)*nx*ny*PML);	        \
  bzero(Hbyx,sizeof(float)*nx*ny*PML);	        \
  bzero(Hbyz,sizeof(float)*nx*ny*PML);	        \
  bzero(Hbzx,sizeof(float)*nx*ny*PML);	        \
  bzero(Hbzy,sizeof(float)*nx*ny*PML);	        \
  for(i=0;i<nx;i++)							      \
    for(j=0;j<ny;j++)							      \
      for(k=0;k<nz;k++)							      \
      {									      \
	if( k< (d/2 + (float)z0) && k>= ((float)z0-d/2) )		      \
	  Cb[posit(i,j,k)] = dt/(dx*indexs[1]*indexs[1]*EPSILON_0);	      \
	else if(  k < ((float)z0-d/2) )					      \
	  Cb[posit(i,j,k)] = dt/(dx*indexs[2]*indexs[2]*EPSILON_0);	      \
	else								      \
	  Cb[posit(i,j,k)] = dt/(dx*indexs[0]*indexs[0]*EPSILON_0);	      \
	if( k< (d/2 + (float)z0) && k>= ((float)z0+d/2-t) )		      \
	{								      \
	  if( (float)(i-x0)*(float)(i-x0) + (float)(j-y0)*(float)(j-y0)<=r*r )\
	    Cb[posit(i,j,k)] = dt/(dx*indexs[3]*indexs[3]*EPSILON_0);	      \
	}								      \
      }									      \
  Db = dt/(dx*MU_0);

#define E_FIELD_PML_UP								  \
  Euxy[pml(i,j,k)] = (1-dt*sigma[k]/(EPSILON_0*indexs[0]*indexs[0]))*		  \
    Euxy[pml(i,j,k)] + (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Huzx[pml(i,j,k)]+Huzy[pml(i,j,k)])-(Huzx[pml(i,j-1,k)]+Huzy[pml(i,j-1,k)]));\
  Euxz[pml(i,j,k)] = (1-dt*sigma[k]/(EPSILON_0*indexs[0]*indexs[0]))*		  \
    Euxz[pml(i,j,k)] - (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Huyx[pml(i,j,k)]+Huyz[pml(i,j,k)])-(Huyx[pml(i,j,k-1)]+Huyz[pml(i,j,k-1)]));\
  Euyx[pml(i,j,k)] = (1-dt*sigma[k]/(EPSILON_0*indexs[0]*indexs[0]))*		  \
    Euyx[pml(i,j,k)] - (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Huzx[pml(i,j,k)]+Huzy[pml(i,j,k)])-(Huzx[pml(i-1,j,k)]+Huzy[pml(i-1,j,k)]));\
  Euyz[pml(i,j,k)] = (1-dt*sigma[k]/(EPSILON_0*indexs[0]*indexs[0]))*		  \
    Euyz[pml(i,j,k)] + (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Huxy[pml(i,j,k)]+Huxz[pml(i,j,k)])-(Huxy[pml(i,j,k-1)]+Huxz[pml(i,j,k-1)]));\
  Euzx[pml(i,j,k)] = (1-dt*sigma[k]/(EPSILON_0*indexs[0]*indexs[0]))*		  \
    Euzx[pml(i,j,k)] + (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Huyx[pml(i,j,k)]+Huyz[pml(i,j,k)])-(Huyx[pml(i-1,j,k)]+Huyz[pml(i-1,j,k)]));\
  Euzy[pml(i,j,k)] = (1-dt*sigma[k]/(EPSILON_0*indexs[0]*indexs[0]))*		  \
    Euzy[pml(i,j,k)] - (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Huxy[pml(i,j,k)]+Huxz[pml(i,j,k)])-(Huxy[pml(i,j-1,k)]+Huxz[pml(i,j-1,k)]));

#define E_FIELD_PML_BELOW							  \
  Ebxy[pml(i,j,k)] = (1-dt*sigma[PML-k-1]/(EPSILON_0*indexs[0]*indexs[0]))*	  \
    Ebxy[pml(i,j,k)] + (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Hbzx[pml(i,j,k)]+Hbzy[pml(i,j,k)])-(Hbzx[pml(i,j-1,k)]+Hbzy[pml(i,j-1,k)]));\
  Ebxz[pml(i,j,k)] = (1-dt*sigma[PML-k-1]/(EPSILON_0*indexs[0]*indexs[0]))*	  \
    Ebxz[pml(i,j,k)] - (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Hbyx[pml(i,j,k)]+Hbyz[pml(i,j,k)])-(Hbyx[pml(i,j,k-1)]+Hbyz[pml(i,j,k-1)]));\
  Ebyx[pml(i,j,k)] = (1-dt*sigma[PML-k-1]/(EPSILON_0*indexs[0]*indexs[0]))*	  \
    Ebyx[pml(i,j,k)] - (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Hbzx[pml(i,j,k)]+Hbzy[pml(i,j,k)])-(Hbzx[pml(i-1,j,k)]+Hbzy[pml(i-1,j,k)]));\
  Ebyz[pml(i,j,k)] = (1-dt*sigma[PML-k-1]/(EPSILON_0*indexs[0]*indexs[0]))*	  \
    Ebyz[pml(i,j,k)] + (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Hbxy[pml(i,j,k)]+Hbxz[pml(i,j,k)])-(Hbxy[pml(i,j,k-1)]+Hbxz[pml(i,j,k-1)]));\
  Ebzx[pml(i,j,k)] = (1-dt*sigma[PML-k-1]/(EPSILON_0*indexs[0]*indexs[0]))*	  \
    Ebzx[pml(i,j,k)] + (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Hbyx[pml(i,j,k)]+Hbyz[pml(i,j,k)])-(Hbyx[pml(i-1,j,k)]+Hbyz[pml(i-1,j,k)]));\
  Ebzy[pml(i,j,k)] = (1-dt*sigma[PML-k-1]/(EPSILON_0*indexs[0]*indexs[0]))*	  \
    Ebzy[pml(i,j,k)] - (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Hbxy[pml(i,j,k)]+Hbxz[pml(i,j,k)])-(Hbxy[pml(i,j-1,k)]+Hbxz[pml(i,j-1,k)]));

#define E_FIELD_PML_UP_0            \
  Euxy[pml(i,j,k)] = (1-dt*sigma[k]/(EPSILON_0*indexs[0]*indexs[0]))*		  \
    Euxy[pml(i,j,k)] + (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Huzx[pml(i,j,k)]+Huzy[pml(i,j,k)])-(Huzx[pml(i,j-1,k)]+Huzy[pml(i,j-1,k)]));\
  Euxz[pml(i,j,k)] = (1-dt*sigma[k]/(EPSILON_0*indexs[0]*indexs[0]))*		  \
    Euxz[pml(i,j,k)] - (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Huyx[pml(i,j,k)]+Huyz[pml(i,j,k)])-(Hy[posit(i,j,nz-1)]));		  \
  Euyx[pml(i,j,k)] = (1-dt*sigma[k]/(EPSILON_0*indexs[0]*indexs[0]))*		  \
    Euyx[pml(i,j,k)] - (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Huzx[pml(i,j,k)]+Huzy[pml(i,j,k)])-(Huzx[pml(i-1,j,k)]+Huzy[pml(i-1,j,k)]));\
  Euyz[pml(i,j,k)] = (1-dt*sigma[k]/(EPSILON_0*indexs[0]*indexs[0]))*		  \
    Euyz[pml(i,j,k)] + (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Huxy[pml(i,j,k)]+Huxz[pml(i,j,k)])-(Hx[posit(i,j,nz-1)]));		  \
  Euzx[pml(i,j,k)] = (1-dt*sigma[k]/(EPSILON_0*indexs[0]*indexs[0]))*		  \
    Euzx[pml(i,j,k)] + (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Huyx[pml(i,j,k)]+Huyz[pml(i,j,k)])-(Huyx[pml(i-1,j,k)]+Huyz[pml(i-1,j,k)]));\
  Euzy[pml(i,j,k)] = (1-dt*sigma[k]/(EPSILON_0*indexs[0]*indexs[0]))*		  \
    Euzy[pml(i,j,k)] - (dt/(EPSILON_0*indexs[0]*indexs[0]*dx))*			  \
    ((Huxy[pml(i,j,k)]+Huxz[pml(i,j,k)])-(Huxy[pml(i,j-1,k)]+Huxz[pml(i,j-1,k)]));

#define H_FIELD_PML_UP								  \
  Huxy[pml(i,j,k)] = (1-dt*S*sigma[k]/MU_0)*					  \
    Huxy[pml(i,j,k)] - (dt/(MU_0*dx))*						  \
    ((Euzx[pml(i,j+1,k)]+Euzy[pml(i,j+1,k)])-(Euzx[pml(i,j,k)]+Euzy[pml(i,j,k)]));\
  Huxz[pml(i,j,k)] = (1-dt*S*sigma[k]/MU_0)*					  \
    Huxz[pml(i,j,k)] + (dt/(MU_0*dx))*						  \
    ((Euyx[pml(i,j,k+1)]+Euyz[pml(i,j,k+1)])-(Euyx[pml(i,j,k)]+Euyz[pml(i,j,k)]));\
  Huyz[pml(i,j,k)] = (1-dt*S*sigma[k]/MU_0)*					  \
    Huyz[pml(i,j,k)] - (dt/(MU_0*dx))*						  \
    ((Euxy[pml(i,j,k+1)]+Euxz[pml(i,j,k+1)])-(Euxy[pml(i,j,k)]+Euxz[pml(i,j,k)]));\
  Huyx[pml(i,j,k)] = (1-dt*S*sigma[k]/MU_0)*					  \
    Huyx[pml(i,j,k)] + (dt/(MU_0*dx))*						  \
    ((Euzx[pml(i+1,j,k)]+Euzy[pml(i+1,j,k)])-(Euzx[pml(i,j,k)]+Euzy[pml(i,j,k)]));\
  Huzx[pml(i,j,k)] = (1-dt*S*sigma[k]/MU_0)*					  \
    Huzx[pml(i,j,k)] - (dt/(MU_0*dx))*						  \
    ((Euyx[pml(i+1,j,k)]+Euyz[pml(i+1,j,k)])-(Euyx[pml(i,j,k)]+Euyz[pml(i,j,k)]));\
  Huzy[pml(i,j,k)] = (1-dt*S*sigma[k]/MU_0)*					  \
    Huzy[pml(i,j,k)] + (dt/(MU_0*dx))*						  \
    ((Euxy[pml(i,j+1,k)]+Euxz[pml(i,j+1,k)])-(Euxy[pml(i,j,k)]+Euxz[pml(i,j,k)]));

#define H_FIELD_PML_BELOW							  \
  Hbxy[pml(i,j,k)] = (1-dt*S*sigma[PML-k-1]/MU_0)*				  \
    Hbxy[pml(i,j,k)] - (dt/(MU_0*dx))*						  \
    ((Ebzx[pml(i,j+1,k)]+Ebzy[pml(i,j+1,k)])-(Ebzx[pml(i,j,k)]+Ebzy[pml(i,j,k)]));\
  Hbxz[pml(i,j,k)] = (1-dt*S*sigma[PML-k-1]/MU_0)*				  \
    Hbxz[pml(i,j,k)] + (dt/(MU_0*dx))*						  \
    ((Ebyx[pml(i,j,k+1)]+Ebyz[pml(i,j,k+1)])-(Ebyx[pml(i,j,k)]+Ebyz[pml(i,j,k)]));\
  Hbyz[pml(i,j,k)] = (1-dt*S*sigma[PML-k-1]/MU_0)*				  \
    Hbyz[pml(i,j,k)] - (dt/(MU_0*dx))*						  \
    ((Ebxy[pml(i,j,k+1)]+Ebxz[pml(i,j,k+1)])-(Ebxy[pml(i,j,k)]+Ebxz[pml(i,j,k)]));\
  Hbyx[pml(i,j,k)] = (1-dt*S*sigma[PML-k-1]/MU_0)*				  \
    Hbyx[pml(i,j,k)] + (dt/(MU_0*dx))*						  \
    ((Ebzx[pml(i+1,j,k)]+Ebzy[pml(i+1,j,k)])-(Ebzx[pml(i,j,k)]+Ebzy[pml(i,j,k)]));\
  Hbzx[pml(i,j,k)] = (1-dt*S*sigma[PML-k-1]/MU_0)*				  \
    Hbzx[pml(i,j,k)] - (dt/(MU_0*dx))*						  \
    ((Ebyx[pml(i+1,j,k)]+Ebyz[pml(i+1,j,k)])-(Ebyx[pml(i,j,k)]+Ebyz[pml(i,j,k)]));\
  Hbzy[pml(i,j,k)] = (1-dt*S*sigma[PML-k-1]/MU_0)*				  \
    Hbzy[pml(i,j,k)] + (dt/(MU_0*dx))*						  \
    ((Ebxy[pml(i,j+1,k)]+Ebxz[pml(i,j+1,k)])-(Ebxy[pml(i,j,k)]+Ebxz[pml(i,j,k)]));

#define H_FIELD_PML_BELOW_L         \
  Hbxy[pml(i,j,k)] = (1-dt*S*sigma[PML-k-1]/MU_0)*     \
    Hbxy[pml(i,j,k)] - (dt/(MU_0*dx))*        \
    ((Ebzx[pml(i,j+1,k)]+Ebzy[pml(i,j+1,k)])-(Ebzx[pml(i,j,k)]+Ebzy[pml(i,j,k)]));\
  Hbxz[pml(i,j,k)] = (1-dt*S*sigma[PML-k-1]/MU_0)*     \
    Hbxz[pml(i,j,k)] + (dt/(MU_0*dx))*        \
    ((Ey[posit(i,j,0)])-(Ebyx[pml(i,j,k)]+Ebyz[pml(i,j,k)]));\
  Hbyz[pml(i,j,k)] = (1-dt*S*sigma[PML-k-1]/MU_0)*     \
    Hbyz[pml(i,j,k)] - (dt/(MU_0*dx))*        \
    ((Ex[posit(i,j,0)])-(Ebxy[pml(i,j,k)]+Ebxz[pml(i,j,k)]));\
  Hbyx[pml(i,j,k)] = (1-dt*S*sigma[PML-k-1]/MU_0)*     \
    Hbyx[pml(i,j,k)] + (dt/(MU_0*dx))*        \
    ((Ebzx[pml(i+1,j,k)]+Ebzy[pml(i+1,j,k)])-(Ebzx[pml(i,j,k)]+Ebzy[pml(i,j,k)]));\
  Hbzx[pml(i,j,k)] = (1-dt*S*sigma[PML-k-1]/MU_0)*     \
    Hbzx[pml(i,j,k)] - (dt/(MU_0*dx))*        \
    ((Ebyx[pml(i+1,j,k)]+Ebyz[pml(i+1,j,k)])-(Ebyx[pml(i,j,k)]+Ebyz[pml(i,j,k)]));\
  Hbzy[pml(i,j,k)] = (1-dt*S*sigma[PML-k-1]/MU_0)*     \
    Hbzy[pml(i,j,k)] + (dt/(MU_0*dx))*        \
    ((Ebxy[pml(i,j+1,k)]+Ebxz[pml(i,j+1,k)])-(Ebxy[pml(i,j,k)]+Ebxz[pml(i,j,k)]));

#define E_FIELD_UPDATE	            \
  Ex[posit(i,j,k)] += Cb[posit(i,j,k)]*((Hz[posit(i,j,k)]-Hz[posit(i,j-1,k)]) \
      - (Hy[posit(i,j,k)]-Hy[posit(i,j,k-1)]) );            \
  Ey[posit(i,j,k)] += Cb[posit(i,j,k)]*((Hx[posit(i,j,k)]-Hx[posit(i,j,k-1)]) \
      - (Hz[posit(i,j,k)]-Hz[posit(i-1,j,k)]) );            \
  Ez[posit(i,j,k)] += Cb[posit(i,j,k)]*((Hy[posit(i,j,k)]-Hy[posit(i-1,j,k)]) \
      - (Hx[posit(i,j,k)]-Hx[posit(i,j-1,k)]) );

#define E_FIELD_UPDATE_0            \
  Ex[posit(i,j,k)] += Cb[posit(i,j,k)]*((Hz[posit(i,j,k)]-Hz[posit(i,j-1,k)]) \
      - (Hy[posit(i,j,k)]-(Hbyx[pml(i,j,PML-1)]+Hbyz[pml(i,j,PML-1)])));      \
  Ey[posit(i,j,k)] += Cb[posit(i,j,k)]*((Hx[posit(i,j,k)]-(Hbxy[pml(i,j,PML-1)]+Hbxz[pml(i,j,PML-1)])) \
      - (Hz[posit(i,j,k)]-Hz[posit(i-1,j,k)]) );            \
  Ez[posit(i,j,k)] += Cb[posit(i,j,k)]*((Hy[posit(i,j,k)]-Hy[posit(i-1,j,k)]) \
      - (Hx[posit(i,j,k)]-Hx[posit(i,j-1,k)]) );

#define H_FIELD_UPDATE	            \
  Hx[posit(i,j,k)] += Db*((Ey[posit(i,j,k+1)]-Ey[posit(i,j,k)])	        \
      - (Ez[posit(i,j+1,k)]-Ez[posit(i,j,k)]) );            \
  Hy[posit(i,j,k)] += Db*((Ez[posit(i+1,j,k)]-Ez[posit(i,j,k)])	        \
      - (Ex[posit(i,j,k+1)]-Ex[posit(i,j,k)]) );            \
  Hz[posit(i,j,k)] += Db*((Ex[posit(i,j+1,k)]-Ex[posit(i,j,k)])	        \
      - (Ey[posit(i+1,j,k)]-Ey[posit(i,j,k)]) );

#define H_FIELD_UPDATE_L            \
  Hx[posit(i,j,k)] += Db*(((Euyx[pml(i,j,0)]+Euyz[pml(i,j,0)])-Ey[posit(i,j,k)])      \
      - (Ez[posit(i,j+1,k)]-Ez[posit(i,j,k)]) );            \
  Hy[posit(i,j,k)] += Db*((Ez[posit(i+1,j,k)]-Ez[posit(i,j,k)])	        \
      - ((Euxy[pml(i,j,0)]+Euxz[pml(i,j,0)]) -Ex[posit(i,j,k)]) );        \
  Hz[posit(i,j,k)] += Db*((Ex[posit(i,j+1,k)]-Ex[posit(i,j,k)])	        \
      - (Ey[posit(i+1,j,k)]-Ey[posit(i,j,k)]) );

#define E_FIELD_UPDATE_J0_1             \
  Ex[posit(i,1,k)] = Ex[posit(i,ny-1,k)]*cos(-k2*R2)         \
          - rFx[(i-1)*nz+k]*sin(-k2*R2);           \
  Ez[posit(i,1,k)] = Ez[posit(i,ny-1,k)]*cos(-k2*R2)         \
          - rFz[(i-1)*nz+k]*sin(-k2*R2);

#define E_FIELD_UPDATE_J0_UPML_1             \
  Euxy[pml(i,1,k)] = Euxy[pml(i,ny-1,k)]*cos(-k2*R2)         \
          - rFxy[(i-1)*PML+k]*sin(-k2*R2);           \
  Euxz[pml(i,1,k)] = Euxz[pml(i,ny-1,k)]*cos(-k2*R2)         \
          - rFxz[(i-1)*PML+k]*sin(-k2*R2);           \
  Euzx[pml(i,1,k)] = Euzx[pml(i,ny-1,k)]*cos(-k2*R2)         \
          - rFzx[(i-1)*PML+k]*sin(-k2*R2);		      \
  Euzy[pml(i,1,k)] = Euzy[pml(i,ny-1,k)]*cos(-k2*R2)         \
          - rFzy[(i-1)*PML+k]*sin(-k2*R2);

#define E_FIELD_UPDATE_J0_BPML_1             \
  Ebxy[pml(i,1,k)] = Ebxy[pml(i,ny-1,k)]*cos(-k2*R2)         \
          - rFxy[(i-1)*PML+k]*sin(-k2*R2);           \
  Ebxz[pml(i,1,k)] = Ebxz[pml(i,ny-1,k)]*cos(-k2*R2)         \
          - rFxz[(i-1)*PML+k]*sin(-k2*R2);           \
  Ebzx[pml(i,1,k)] = Ebzx[pml(i,ny-1,k)]*cos(-k2*R2)         \
          - rFzx[(i-1)*PML+k]*sin(-k2*R2);		      \
  Ebzy[pml(i,1,k)] = Ebzy[pml(i,ny-1,k)]*cos(-k2*R2)         \
          - rFzy[(i-1)*PML+k]*sin(-k2*R2);

#define E_FIELD_UPDATE_J0_2             \
  Ex[posit(i,1,k)] = +rFx[(i-1)*nz+k]*sin(-k2*R2)       \
          +Ex[posit(i,ny-1,k)]*cos(-k2*R2);          \
  Ez[posit(i,1,k)] = +rFz[(i-1)*nz+k]*sin(-k2*R2)       \
          +Ez[posit(i,ny-1,k)]*cos(-k2*R2);

#define E_FIELD_UPDATE_J0_UPML_2             \
  Euxy[pml(i,1,k)] = +rFxy[(i-1)*PML+k]*sin(-k2*R2)       \
          +Euxy[pml(i,ny-1,k)]*cos(-k2*R2);          \
  Euxz[pml(i,1,k)] = +rFxz[(i-1)*PML+k]*sin(-k2*R2)       \
          +Euxz[pml(i,ny-1,k)]*cos(-k2*R2);          \
  Euzx[pml(i,1,k)] = +rFzx[(i-1)*PML+k]*sin(-k2*R2)       \
          +Euzx[pml(i,ny-1,k)]*cos(-k2*R2);		\
  Euzy[pml(i,1,k)] = +rFzy[(i-1)*PML+k]*sin(-k2*R2)       \
          +Euzy[pml(i,ny-1,k)]*cos(-k2*R2);

#define E_FIELD_UPDATE_J0_BPML_2             \
  Ebxy[pml(i,1,k)] = +rFxy[(i-1)*PML+k]*sin(-k2*R2)       \
          +Ebxy[pml(i,ny-1,k)]*cos(-k2*R2);          \
  Ebxz[pml(i,1,k)] = +rFxz[(i-1)*PML+k]*sin(-k2*R2)       \
          +Ebxz[pml(i,ny-1,k)]*cos(-k2*R2);          \
  Ebzx[pml(i,1,k)] = +rFzx[(i-1)*PML+k]*sin(-k2*R2)       \
          +Ebzx[pml(i,ny-1,k)]*cos(-k2*R2);		\
  Ebzy[pml(i,1,k)] = +rFzy[(i-1)*PML+k]*sin(-k2*R2)       \
          +Ebzy[pml(i,ny-1,k)]*cos(-k2*R2);

#define E_FIELD_UPDATE_I0_1             \
  Ey[posit(1,j,k)] = Ey[posit(nx-1,j,k)]*cos(-k1*R1)         \
          - rFy[(j-1)*nz+k]*sin(-k1*R1);           \
  Ez[posit(1,j,k)] = Ez[posit(nx-1,j,k)]*cos(-k1*R1)         \
          - rFz[(j-1)*nz+k]*sin(-k1*R1);

#define E_FIELD_UPDATE_I0_UPML_1             \
  Euyx[pml(1,j,k)] = Euyx[pml(nx-1,j,k)]*cos(-k1*R1)         \
          - rFyx[(j-1)*PML+k]*sin(-k1*R1);           \
  Euyz[pml(1,j,k)] = Euyz[pml(nx-1,j,k)]*cos(-k1*R1)         \
          - rFyz[(j-1)*PML+k]*sin(-k1*R1);           \
  Euzx[pml(1,j,k)] = Euzx[pml(nx-1,j,k)]*cos(-k1*R1)         \
          - rFzx[(j-1)*PML+k]*sin(-k1*R1);		    \
  Euzy[pml(1,j,k)] = Euzy[pml(nx-1,j,k)]*cos(-k1*R1)         \
          - rFzy[(j-1)*PML+k]*sin(-k1*R1);

#define E_FIELD_UPDATE_I0_BPML_1             \
  Ebyx[pml(1,j,k)] = Ebyx[pml(nx-1,j,k)]*cos(-k1*R1)         \
          - rFyx[(j-1)*PML+k]*sin(-k1*R1);           \
  Ebyz[pml(1,j,k)] = Ebyz[pml(nx-1,j,k)]*cos(-k1*R1)         \
          - rFyz[(j-1)*PML+k]*sin(-k1*R1);           \
  Ebzx[pml(1,j,k)] = Ebzx[pml(nx-1,j,k)]*cos(-k1*R1)         \
          - rFzx[(j-1)*PML+k]*sin(-k1*R1);		    \
  Ebzy[pml(1,j,k)] = Ebzy[pml(nx-1,j,k)]*cos(-k1*R1)         \
          - rFzy[(j-1)*PML+k]*sin(-k1*R1);

#define E_FIELD_UPDATE_I0_2             \
  Ey[posit(1,j,k)] = +rFy[(j-1)*nz+k]*sin(-k1*R1)       \
          +Ey[posit(nx-1,j,k)]*cos(-k1*R1);          \
  Ez[posit(1,j,k)] = +rFz[(j-1)*nz+k]*sin(-k1*R1)       \
          +Ez[posit(nx-1,j,k)]*cos(-k1*R1);

#define E_FIELD_UPDATE_I0_UPML_2             \
  Euyx[pml(1,j,k)] = +rFyx[(j-1)*PML+k]*sin(-k1*R1)       \
          +Euyx[pml(nx-1,j,k)]*cos(-k1*R1);          \
  Euyz[pml(1,j,k)] = +rFyz[(j-1)*PML+k]*sin(-k1*R1)       \
          +Euyz[pml(nx-1,j,k)]*cos(-k1*R1);          \
  Euzx[pml(1,j,k)] = +rFzx[(j-1)*PML+k]*sin(-k1*R1)       \
          +Euzx[pml(nx-1,j,k)]*cos(-k1*R1);		\
  Euzy[pml(1,j,k)] = +rFzy[(j-1)*PML+k]*sin(-k1*R1)       \
          +Euzy[pml(nx-1,j,k)]*cos(-k1*R1);

#define E_FIELD_UPDATE_I0_BPML_2             \
  Ebyx[pml(1,j,k)] = +rFyx[(j-1)*PML+k]*sin(-k1*R1)       \
          +Ebyx[pml(nx-1,j,k)]*cos(-k1*R1);          \
  Ebyz[pml(1,j,k)] = +rFyz[(j-1)*PML+k]*sin(-k1*R1)       \
          +Ebyz[pml(nx-1,j,k)]*cos(-k1*R1);          \
  Ebzx[pml(1,j,k)] = +rFzx[(j-1)*PML+k]*sin(-k1*R1)       \
          +Ebzx[pml(nx-1,j,k)]*cos(-k1*R1);		\
  Ebzy[pml(1,j,k)] = +rFzy[(j-1)*PML+k]*sin(-k1*R1)       \
          +Ebzy[pml(nx-1,j,k)]*cos(-k1*R1);


#define H_FIELD_UPDATE_NJ_1             \
  Hx[posit(i,ny-1,k)] = Hx[posit(i,1,k)]*cos(k2*R2)           \
          -rFx[(i-1)*nz+k]*sin(k2*R2);            \
  Hy[posit(i,ny-1,k)] = Hy[posit(i,1,k)]*cos(k2*R2)           \
          -rFy[(i-1)*nz+k]*sin(k2*R2);            \
  Hz[posit(i,ny-1,k)] = Hz[posit(i,1,k)]*cos(k2*R2)           \
          -rFz[(i-1)*nz+k]*sin(k2*R2);

#define H_FIELD_UPDATE_NJ_UPML_1			\
  Huxy[pml(i,ny-1,k)] = Huxy[pml(i,1,k)]*cos(k2*R2)	\
          -rFxy[(i-1)*PML+k]*sin(k2*R2);		\
  Huxz[pml(i,ny-1,k)] = Huxz[pml(i,1,k)]*cos(k2*R2)	\
          -rFxz[(i-1)*PML+k]*sin(k2*R2);		\
  Huyx[pml(i,ny-1,k)] = Huyx[pml(i,1,k)]*cos(k2*R2)     \
          -rFyx[(i-1)*PML+k]*sin(k2*R2);		\
  Huyz[pml(i,ny-1,k)] = Huyz[pml(i,1,k)]*cos(k2*R2)     \
          -rFyz[(i-1)*PML+k]*sin(k2*R2);		\
  Huzx[pml(i,ny-1,k)] = Huzx[pml(i,1,k)]*cos(k2*R2)     \
          -rFzx[(i-1)*PML+k]*sin(k2*R2);		\
  Huzy[pml(i,ny-1,k)] = Huzy[pml(i,1,k)]*cos(k2*R2)     \
          -rFzy[(i-1)*PML+k]*sin(k2*R2);

#define H_FIELD_UPDATE_NJ_BPML_1             \
  Hbxy[pml(i,ny-1,k)] = Hbxy[pml(i,1,k)]*cos(k2*R2)           \
          -rFxy[(i-1)*PML+k]*sin(k2*R2);            \
  Hbxz[pml(i,ny-1,k)] = Hbxz[pml(i,1,k)]*cos(k2*R2)           \
          -rFxz[(i-1)*PML+k]*sin(k2*R2);            \
  Hbyx[pml(i,ny-1,k)] = Hbyx[pml(i,1,k)]*cos(k2*R2)           \
          -rFyx[(i-1)*PML+k]*sin(k2*R2);            \
  Hbyz[pml(i,ny-1,k)] = Hbyz[pml(i,1,k)]*cos(k2*R2)           \
          -rFyz[(i-1)*PML+k]*sin(k2*R2);            \
  Hbzx[pml(i,ny-1,k)] = Hbzx[pml(i,1,k)]*cos(k2*R2)           \
          -rFzx[(i-1)*PML+k]*sin(k2*R2);			      \
  Hbzy[pml(i,ny-1,k)] = Hbzy[pml(i,1,k)]*cos(k2*R2)           \
          -rFzy[(i-1)*PML+k]*sin(k2*R2);

#define H_FIELD_UPDATE_NJ_2             \
  Hx[posit(i,ny-1,k)] = rFx[(i-1)*nz+k]*sin(k2*R2)           \
          +Hx[posit(i,1,k)]*cos(k2*R2);        \
  Hy[posit(i,ny-1,k)] = rFy[(i-1)*nz+k]*sin(k2*R2)           \
          +Hy[posit(i,1,k)]*cos(k2*R2);        \
  Hz[posit(i,ny-1,k)] = rFz[(i-1)*nz+k]*sin(k2*R2)           \
          +Hz[posit(i,1,k)]*cos(k2*R2);

#define H_FIELD_UPDATE_NJ_UPML_2             \
  Huxy[pml(i,ny-1,k)] = rFxy[(i-1)*PML+k]*sin(k2*R2)           \
          +Huxy[pml(i,1,k)]*cos(k2*R2);        \
  Huxz[pml(i,ny-1,k)] = rFxz[(i-1)*PML+k]*sin(k2*R2)           \
          +Huxz[pml(i,1,k)]*cos(k2*R2);        \
  Huyx[pml(i,ny-1,k)] = rFyx[(i-1)*PML+k]*sin(k2*R2)           \
          +Huyx[pml(i,1,k)]*cos(k2*R2);        \
  Huyz[pml(i,ny-1,k)] = rFyz[(i-1)*PML+k]*sin(k2*R2)           \
          +Huyz[pml(i,1,k)]*cos(k2*R2);        \
  Huzx[pml(i,ny-1,k)] = rFzx[(i-1)*PML+k]*sin(k2*R2)           \
          +Huzx[pml(i,1,k)]*cos(k2*R2);			      \
  Huzy[pml(i,ny-1,k)] = rFzy[(i-1)*PML+k]*sin(k2*R2)           \
          +Huzy[pml(i,1,k)]*cos(k2*R2);

#define H_FIELD_UPDATE_NJ_BPML_2             \
  Hbxy[pml(i,ny-1,k)] = rFxy[(i-1)*PML+k]*sin(k2*R2)           \
          +Hbxy[pml(i,1,k)]*cos(k2*R2);        \
  Hbxz[pml(i,ny-1,k)] = rFxz[(i-1)*PML+k]*sin(k2*R2)           \
          +Hbxz[pml(i,1,k)]*cos(k2*R2);        \
  Hbyx[pml(i,ny-1,k)] = rFyx[(i-1)*PML+k]*sin(k2*R2)           \
          +Hbyx[pml(i,1,k)]*cos(k2*R2);        \
  Hbyz[pml(i,ny-1,k)] = rFyz[(i-1)*PML+k]*sin(k2*R2)           \
          +Hbyz[pml(i,1,k)]*cos(k2*R2);        \
  Hbzx[pml(i,ny-1,k)] = rFzx[(i-1)*PML+k]*sin(k2*R2)           \
          +Hbzx[pml(i,1,k)]*cos(k2*R2);			      \
  Hbzy[pml(i,ny-1,k)] = rFzy[(i-1)*PML+k]*sin(k2*R2)           \
          +Hbzy[pml(i,1,k)]*cos(k2*R2);

#define H_FIELD_UPDATE_NI_1             \
  Hx[posit(nx-1,j,k)] = Hx[posit(1,j,k)]*cos(k1*R1)           \
          -rFx[(j-1)*nz+k]*sin(k1*R1);            \
  Hy[posit(nx-1,j,k)] = Hy[posit(1,j,k)]*cos(k1*R1)           \
          -rFy[(j-1)*nz+k]*sin(k1*R1);            \
  Hz[posit(nx-1,j,k)] = Hz[posit(1,j,k)]*cos(k1*R1)           \
          -rFz[(j-1)*nz+k]*sin(k1*R1);

#define H_FIELD_UPDATE_NI_UPML_1             \
  Huxy[pml(nx-1,j,k)] = Huxy[pml(1,j,k)]*cos(k1*R1)           \
          -rFxy[(j-1)*PML+k]*sin(k1*R1);            \
  Huxz[pml(nx-1,j,k)] = Huxz[pml(1,j,k)]*cos(k1*R1)           \
          -rFxz[(j-1)*PML+k]*sin(k1*R1);            \
  Huyx[pml(nx-1,j,k)] = Huyx[pml(1,j,k)]*cos(k1*R1)           \
          -rFyx[(j-1)*PML+k]*sin(k1*R1);            \
  Huyz[pml(nx-1,j,k)] = Huyz[pml(1,j,k)]*cos(k1*R1)           \
          -rFyz[(j-1)*PML+k]*sin(k1*R1);            \
  Huzx[pml(nx-1,j,k)] = Huzx[pml(1,j,k)]*cos(k1*R1)           \
          -rFzx[(j-1)*PML+k]*sin(k1*R1);			      \
  Huzy[pml(nx-1,j,k)] = Huzy[pml(1,j,k)]*cos(k1*R1)           \
          -rFzy[(j-1)*PML+k]*sin(k1*R1);

#define H_FIELD_UPDATE_NI_BPML_1             \
  Hbxy[pml(nx-1,j,k)] = Hbxy[pml(1,j,k)]*cos(k1*R1)           \
          -rFxy[(j-1)*PML+k]*sin(k1*R1);            \
  Hbxz[pml(nx-1,j,k)] = Hbxz[pml(1,j,k)]*cos(k1*R1)           \
          -rFxz[(j-1)*PML+k]*sin(k1*R1);            \
  Hbyx[pml(nx-1,j,k)] = Hbyx[pml(1,j,k)]*cos(k1*R1)           \
          -rFyx[(j-1)*PML+k]*sin(k1*R1);            \
  Hbyz[pml(nx-1,j,k)] = Hbyz[pml(1,j,k)]*cos(k1*R1)           \
          -rFyz[(j-1)*PML+k]*sin(k1*R1);            \
  Hbzx[pml(nx-1,j,k)] = Hbzx[pml(1,j,k)]*cos(k1*R1)           \
          -rFzx[(j-1)*PML+k]*sin(k1*R1);			      \
  Hbzy[pml(nx-1,j,k)] = Hbzy[pml(1,j,k)]*cos(k1*R1)           \
          -rFzy[(j-1)*PML+k]*sin(k1*R1);

#define H_FIELD_UPDATE_NI_2             \
  Hx[posit(nx-1,j,k)] = rFx[(j-1)*nz+k]*sin(k1*R1)           \
          +Hx[posit(1,j,k)]*cos(k1*R1);        \
  Hy[posit(nx-1,j,k)] = rFy[(j-1)*nz+k]*sin(k1*R1)           \
          +Hy[posit(1,j,k)]*cos(k1*R1);        \
  Hz[posit(nx-1,j,k)] = rFz[(j-1)*nz+k]*sin(k1*R1)           \
          +Hz[posit(1,j,k)]*cos(k1*R1);

#define H_FIELD_UPDATE_NI_UPML_2             \
  Huxy[pml(nx-1,j,k)] = rFxy[(j-1)*PML+k]*sin(k1*R1)           \
          +Huxy[pml(1,j,k)]*cos(k1*R1);        \
  Huxz[pml(nx-1,j,k)] = rFxz[(j-1)*PML+k]*sin(k1*R1)           \
          +Huxz[pml(1,j,k)]*cos(k1*R1);        \
  Huyx[pml(nx-1,j,k)] = rFyx[(j-1)*PML+k]*sin(k1*R1)           \
          +Huyx[pml(1,j,k)]*cos(k1*R1);        \
  Huyz[pml(nx-1,j,k)] = rFyz[(j-1)*PML+k]*sin(k1*R1)           \
          +Huyz[pml(1,j,k)]*cos(k1*R1);        \
  Huzx[pml(nx-1,j,k)] = rFzx[(j-1)*PML+k]*sin(k1*R1)           \
          +Huzx[pml(1,j,k)]*cos(k1*R1);			    \
  Huzy[pml(nx-1,j,k)] = rFzy[(j-1)*PML+k]*sin(k1*R1)           \
          +Huzy[pml(1,j,k)]*cos(k1*R1);

#define H_FIELD_UPDATE_NI_BPML_2             \
  Hbxy[pml(nx-1,j,k)] = rFxy[(j-1)*PML+k]*sin(k1*R1)           \
          +Hbxy[pml(1,j,k)]*cos(k1*R1);        \
  Hbxz[pml(nx-1,j,k)] = rFxz[(j-1)*PML+k]*sin(k1*R1)           \
          +Hbxz[pml(1,j,k)]*cos(k1*R1);        \
  Hbyx[pml(nx-1,j,k)] = rFyx[(j-1)*PML+k]*sin(k1*R1)           \
          +Hbyx[pml(1,j,k)]*cos(k1*R1);        \
  Hbyz[pml(nx-1,j,k)] = rFyz[(j-1)*PML+k]*sin(k1*R1)           \
          +Hbyz[pml(1,j,k)]*cos(k1*R1);        \
  Hbzx[pml(nx-1,j,k)] = rFzx[(j-1)*PML+k]*sin(k1*R1)           \
          +Hbzx[pml(1,j,k)]*cos(k1*R1);			    \
  Hbzy[pml(nx-1,j,k)] = rFzy[(j-1)*PML+k]*sin(k1*R1)           \
          +Hbzy[pml(1,j,k)]*cos(k1*R1);

#define LOAD_INFO_FILE	            \
  if(node == 0) printf("step 1 : Loading the information file");        \
  info = fopen("pbc.info","r");	          \
  fscanf(info,"%f",&indexs[0]);	          \
  fscanf(info,"%f",&indexs[1]);	          \
  fscanf(info,"%f",&indexs[2]);	          \
  fscanf(info,"%f",&indexs[3]);	          \
  fscanf(info,"%f",&a);	            \
  fscanf(info,"%f",&r);	            \
  fscanf(info,"%d",&type);              \
  fscanf(info,"%f",&d);	            \
  fscanf(info,"%f",&t);	            \
  fscanf(info,"%f",&freq);              \
  fscanf(info,"%f",&dx);            \
  fscanf(info,"%f",&dt);            \
  fscanf(info,"%f",&fnz);           \
  fscanf(info,"%ld",&max_iter);	          \
  fscanf(info,"%f",&k1);            \
  fscanf(info,"%f",&k2);            \
  fscanf(info,"%d",&sx);            \
  fscanf(info,"%d",&sy);            \
  fscanf(info,"%d",&sz);            \
  fclose(info);	              \
  r = r*a;            \
  d = d*a;            \
  t = t*a;            \
  if(node ==0) printf("................OK\n");

#define MAKE_STRUCTURE	            \
  if(node == 0) printf("step 2 : Making structure");          \
  if(type == 1){              \
    MAKE_TRI_STRUCTURE;	            \
  }             \
  else if(type == 2){	        \
    MAKE_SQUARE_STRUCTURE;              \
  }             \
  else	          \
    panic("lattice type misselected!");	        \
  if(node ==0) printf("................OK\n");


#define Packi	            \
  pos=0;	            \
    for(i=1;i<nx;i++)           \
      for(k=0;k<nz;k++) {	        \
	dummy[pos] = Ex[posit(i,j,k)];       \
	pos++;	        \
      }	          \
    for(i=1;i<nx;i++)           \
      for(k=0;k<nz;k++) {	        \
	dummy[pos] = Ey[posit(i,j,k)];       \
	pos++;	        \
      }	          \
    for(i=1;i<nx;i++)           \
      for(k=0;k<nz;k++) {	        \
	dummy[pos] = Ez[posit(i,j,k)];       \
	pos++;	        \
      }

#define Unpacki		      \
    pos=0;	            \
    for(i=1;i<nx;i++)           \
      for(k=0;k<nz;k++) {	        \
	rFx[(i-1)*nz+k] = dummy[pos];	      \
	pos++;	        \
      }	          \
    for(i=1;i<nx;i++)           \
      for(k=0;k<nz;k++) {	        \
	rFy[(i-1)*nz+k] = dummy[pos];	      \
	pos++;	        \
      }	          \
    for(i=1;i<nx;i++)           \
      for(k=0;k<nz;k++) {	        \
	rFz[(i-1)*nz+k] = dummy[pos];	      \
	pos++;	        \
      }	          

#define Packj	            \
    pos=0;	            \
    for(j=1;j<ny;j++)	      \
      for(k=0;k<nz;k++) {	        \
	dummy[pos] = Ex[posit(i,j,k)];       \
	pos++;	        \
      }	          \
    for(j=1;j<ny;j++)	      \
      for(k=0;k<nz;k++) {	        \
	dummy[pos] = Ey[posit(i,j,k)];       \
	pos++;	        \
      }	          \
    for(j=1;j<ny;j++)	      \
      for(k=0;k<nz;k++) {	        \
	dummy[pos] = Ez[posit(i,j,k)];       \
	pos++;	        \
      }

#define Unpackj		      \
    pos=0;	            \
    for(j=1;j<ny;j++)	      \
      for(k=0;k<nz;k++) {	        \
	rFx[(j-1)*nz+k] = dummy[pos];	      \
	pos++;	        \
      }	          \
    for(j=1;j<ny;j++)	      \
      for(k=0;k<nz;k++) {	        \
	rFy[(j-1)*nz+k] = dummy[pos];	      \
	pos++;	        \
      }	          \
    for(j=1;j<ny;j++)	      \
      for(k=0;k<nz;k++) {	        \
	rFz[(j-1)*nz+k] = dummy[pos];	      \
	pos++;	        \
      }

#define PackHj		      \
  pos=0;	            \
  for(j=1;j<ny;j++)	      \
    for(k=0;k<nz;k++) {	        \
      dummy[pos] = Hx[posit(i,j,k)];       \
      pos++;	        \
    }	          \
  for(j=1;j<ny;j++)	      \
    for(k=0;k<nz;k++) {	        \
      dummy[pos] = Hy[posit(i,j,k)];       \
      pos++;	        \
    }	          \
  for(j=1;j<ny;j++)	      \
    for(k=0;k<nz;k++) {	        \
      dummy[pos] = Hz[posit(i,j,k)];       \
      pos++;	        \
    }

#define UnpackHj	        \
  pos=0;	            \
  for(j=1;j<ny;j++)	      \
    for(k=0;k<nz;k++) {	        \
      rFx[(j-1)*nz+k] = dummy[pos];	      \
      pos++;	        \
    }	          \
  for(j=1;j<ny;j++)	      \
    for(k=0;k<nz;k++) {	        \
      rFy[(j-1)*nz+k] = dummy[pos];	      \
      pos++;	        \
    }	          \
  for(j=1;j<ny;j++)	      \
    for(k=0;k<nz;k++) {	        \
      rFz[(j-1)*nz+k] = dummy[pos];	      \
      pos++;	        \
    }

#define  PackHi		      \
  pos=0;	            \
  for(i=1;i<nx;i++)           \
    for(k=0;k<nz;k++) {	        \
      dummy[pos] = Hx[posit(i,j,k)];       \
      pos++;	        \
    }	          \
  for(i=1;i<nx;i++)           \
    for(k=0;k<nz;k++) {	        \
      dummy[pos] = Hy[posit(i,j,k)];       \
      pos++;	        \
    }	          \
  for(i=1;i<nx;i++)           \
    for(k=0;k<nz;k++) {	        \
      dummy[pos] = Hz[posit(i,j,k)];       \
      pos++;	        \
    }

#define UnpackHi	        \
  pos=0;	            \
  for(i=1;i<nx;i++)           \
    for(k=0;k<nz;k++) {	        \
      rFx[(i-1)*nz+k] = dummy[pos];	      \
      pos++;	        \
    }	          \
  for(i=1;i<nx;i++)           \
    for(k=0;k<nz;k++) {	        \
      rFy[(i-1)*nz+k] = dummy[pos];	      \
      pos++;	        \
    }	          \
  for(i=1;i<nx;i++)           \
    for(k=0;k<nz;k++) {	        \
      rFz[(i-1)*nz+k] = dummy[pos];	      \
      pos++;	        \
    }	          



#define PackUPMLi	            \
  pos=0;	            \
    for(i=1;i<nx;i++)           \
      for(k=0;k<PML;k++) {	        \
	dummy_pml[pos] = Euxy[pml(i,j,k)];       \
	pos++;	        \
	dummy_pml[pos] = Euxz[pml(i,j,k)];       \
	pos++;	        \
      }	          \
    for(i=1;i<nx;i++)           \
      for(k=0;k<PML;k++) {	        \
	dummy_pml[pos] = Euyx[pml(i,j,k)];       \
	pos++;	        \
	dummy_pml[pos] = Euyz[pml(i,j,k)];       \
	pos++;	        \
      }	          \
    for(i=1;i<nx;i++)           \
      for(k=0;k<PML;k++) {	        \
	dummy_pml[pos] = Euzx[pml(i,j,k)];       \
	pos++;	        \
	dummy_pml[pos] = Euzy[pml(i,j,k)];       \
	pos++;	        \
      }

#define UnpackPMLi		      \
    pos=0;	            \
    for(i=1;i<nx;i++)           \
      for(k=0;k<PML;k++) {	        \
	rFxy[(i-1)*PML+k] = dummy_pml[pos];	      \
	pos++;	        \
	rFxz[(i-1)*PML+k] = dummy_pml[pos];	      \
	pos++;	        \
      }	          \
    for(i=1;i<nx;i++)           \
      for(k=0;k<PML;k++) {	        \
	rFyx[(i-1)*PML+k] = dummy_pml[pos];	      \
	pos++;	        \
	rFyz[(i-1)*PML+k] = dummy_pml[pos];	      \
	pos++;	        \
      }	          \
    for(i=1;i<nx;i++)           \
      for(k=0;k<PML;k++) {	        \
	rFzx[(i-1)*PML+k] = dummy_pml[pos];	      \
	pos++;	        \
	rFzy[(i-1)*PML+k] = dummy_pml[pos];	      \
	pos++;	        \
      }	          

#define PackUPMLj	            \
    pos=0;	            \
    for(j=1;j<ny;j++)	      \
      for(k=0;k<PML;k++) {	        \
	dummy_pml[pos] = Euxy[pml(i,j,k)];       \
	pos++;	        \
	dummy_pml[pos] = Euxz[pml(i,j,k)];       \
	pos++;	        \
      }	          \
    for(j=1;j<ny;j++)	      \
      for(k=0;k<PML;k++) {	        \
	dummy_pml[pos] = Euyx[pml(i,j,k)];       \
	pos++;	        \
	dummy_pml[pos] = Euyz[pml(i,j,k)];       \
	pos++;	        \
      }	          \
    for(j=1;j<ny;j++)	      \
      for(k=0;k<PML;k++) {	        \
	dummy_pml[pos] = Euzx[pml(i,j,k)];       \
	pos++;	        \
	dummy_pml[pos] = Euzy[pml(i,j,k)];       \
	pos++;	        \
      }

#define UnpackPMLj				\
    pos=0;					\
    for(j=1;j<ny;j++)				\
      for(k=0;k<PML;k++) {			\
	rFxy[(j-1)*PML+k] = dummy_pml[pos];     \
	pos++;					\
	rFxz[(j-1)*PML+k] = dummy_pml[pos];     \
	pos++;					\
      }						\
    for(j=1;j<ny;j++)				\
      for(k=0;k<PML;k++) {			\
	rFyx[(j-1)*PML+k] = dummy_pml[pos];     \
	pos++;					\
	rFyz[(j-1)*PML+k] = dummy_pml[pos];     \
	pos++;					\
      }						\
    for(j=1;j<ny;j++)				\
      for(k=0;k<PML;k++) {			\
	rFzx[(j-1)*PML+k] = dummy_pml[pos];     \
	pos++;					\
	rFzy[(j-1)*PML+k] = dummy_pml[pos];     \
	pos++;					\
      }	          

#define PackHUPMLj		      \
  pos=0;	            \
  for(j=1;j<ny;j++)	      \
    for(k=0;k<PML;k++) {	        \
      dummy_pml[pos] = Huxy[pml(i,j,k)];       \
      pos++;	        \
      dummy_pml[pos] = Huxz[pml(i,j,k)];       \
      pos++;	        \
    }	          \
  for(j=1;j<ny;j++)	      \
    for(k=0;k<PML;k++) {	        \
      dummy_pml[pos] = Huyx[pml(i,j,k)];       \
      pos++;	        \
      dummy_pml[pos] = Huyz[pml(i,j,k)];       \
      pos++;	        \
    }	          \
  for(j=1;j<ny;j++)	      \
    for(k=0;k<PML;k++) {	        \
      dummy_pml[pos] = Huzx[pml(i,j,k)];       \
      pos++;	        \
      dummy_pml[pos] = Huzy[pml(i,j,k)];       \
      pos++;	        \
    }


#define  PackHUPMLi		      \
  pos=0;	            \
  for(i=1;i<nx;i++)           \
    for(k=0;k<PML;k++) {	        \
      dummy_pml[pos] = Huxy[pml(i,j,k)];       \
      pos++;	        \
      dummy_pml[pos] = Huxz[pml(i,j,k)];       \
      pos++;	        \
    }	          \
  for(i=1;i<nx;i++)           \
    for(k=0;k<PML;k++) {	        \
      dummy_pml[pos] = Huyx[pml(i,j,k)];       \
      pos++;	        \
      dummy_pml[pos] = Huyz[pml(i,j,k)];       \
      pos++;	        \
    }	          \
  for(i=1;i<nx;i++)           \
    for(k=0;k<PML;k++) {	        \
      dummy_pml[pos] = Huzx[pml(i,j,k)];       \
      pos++;	        \
      dummy_pml[pos] = Huzy[pml(i,j,k)];       \
      pos++;	        \
    }




#define PackBPMLi	            \
  pos=0;	            \
    for(i=1;i<nx;i++)           \
      for(k=0;k<PML;k++) {	        \
	dummy_pml[pos] = Ebxy[pml(i,j,k)];       \
	pos++;	        \
	dummy_pml[pos] = Ebxz[pml(i,j,k)];       \
	pos++;	        \
      }	          \
    for(i=1;i<nx;i++)           \
      for(k=0;k<PML;k++) {	        \
	dummy_pml[pos] = Ebyx[pml(i,j,k)];       \
	pos++;	        \
	dummy_pml[pos] = Ebyz[pml(i,j,k)];       \
	pos++;	        \
      }	          \
    for(i=1;i<nx;i++)           \
      for(k=0;k<PML;k++) {	        \
	dummy_pml[pos] = Ebzx[pml(i,j,k)];       \
	pos++;	        \
	dummy_pml[pos] = Ebzy[pml(i,j,k)];       \
	pos++;	        \
      }


#define PackBPMLj	            \
    pos=0;	            \
    for(j=1;j<ny;j++)	      \
      for(k=0;k<PML;k++) {	        \
	dummy_pml[pos] = Ebxy[pml(i,j,k)];       \
	pos++;	        \
	dummy_pml[pos] = Ebxz[pml(i,j,k)];       \
	pos++;	        \
      }	          \
    for(j=1;j<ny;j++)	      \
      for(k=0;k<PML;k++) {	        \
	dummy_pml[pos] = Ebyx[pml(i,j,k)];       \
	pos++;	        \
	dummy_pml[pos] = Ebyz[pml(i,j,k)];       \
	pos++;	        \
      }	          \
    for(j=1;j<ny;j++)	      \
      for(k=0;k<PML;k++) {	        \
	dummy_pml[pos] = Ebzx[pml(i,j,k)];       \
	pos++;	        \
	dummy_pml[pos] = Ebzy[pml(i,j,k)];       \
	pos++;	        \
      }


#define PackHBPMLj		      \
  pos=0;	            \
  for(j=1;j<ny;j++)	      \
    for(k=0;k<PML;k++) {	        \
      dummy_pml[pos] = Hbxy[pml(i,j,k)];       \
      pos++;	        \
      dummy_pml[pos] = Hbxz[pml(i,j,k)];       \
      pos++;	        \
    }	          \
  for(j=1;j<ny;j++)	      \
    for(k=0;k<PML;k++) {	        \
      dummy_pml[pos] = Hbyx[pml(i,j,k)];       \
      pos++;	        \
      dummy_pml[pos] = Hbyz[pml(i,j,k)];       \
      pos++;	        \
    }	          \
  for(j=1;j<ny;j++)	      \
    for(k=0;k<PML;k++) {	        \
      dummy_pml[pos] = Hbzx[pml(i,j,k)];       \
      pos++;	        \
      dummy_pml[pos] = Hbzy[pml(i,j,k)];       \
      pos++;	        \
    }


#define  PackHBPMLi		      \
  pos=0;	            \
  for(i=1;i<nx;i++)           \
    for(k=0;k<PML;k++) {	        \
      dummy_pml[pos] = Hbxy[pml(i,j,k)];       \
      pos++;	        \
      dummy_pml[pos] = Hbxz[pml(i,j,k)];       \
      pos++;	        \
    }	          \
  for(i=1;i<nx;i++)           \
    for(k=0;k<PML;k++) {	        \
      dummy_pml[pos] = Hbyx[pml(i,j,k)];       \
      pos++;	        \
      dummy_pml[pos] = Hbyz[pml(i,j,k)];       \
      pos++;	        \
    }	          \
  for(i=1;i<nx;i++)           \
    for(k=0;k<PML;k++) {	        \
      dummy_pml[pos] = Hbzx[pml(i,j,k)];       \
      pos++;	        \
      dummy_pml[pos] = Hbzy[pml(i,j,k)];       \
      pos++;	        \
    }


void panic(char *message)
{
  fprintf(stderr,"Fatal : %s\n",message);
  exit(-1);
}



